#define _CRT_SECURE_NO_WARNINGS
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <inttypes.h>
#include <psapi.h>
#pragma comment( linker, "/section:.text,RWE" )

HMODULE D3D9_o = NULL;

extern "C" {
	LPBYTE imp_Direct3DCreate9 = nullptr;
}

static bool __declspec(noinline) bDataCompare( const BYTE* pData, const BYTE* bMask, const char* szMask )
{
	for( ; *szMask; ++szMask, ++pData, ++bMask )
	{
		if( *szMask == 'x' && *pData != *bMask )
			return FALSE;
	}

	return ( *szMask ) == NULL;
}

static uint8_t __declspec(noinline)* FindPattern(BYTE* bMask, const char* szMask)
{
	MODULEINFO moduleInfo = { 0 };

	HMODULE hModule = GetModuleHandle("pros.sdk.x64.dll");
	if (hModule == NULL) return 0;
	GetModuleInformation( GetCurrentProcess(), hModule, &moduleInfo, sizeof(MODULEINFO) );

	uint8_t* dwBaseAddress = (uint8_t*)moduleInfo.lpBaseOfDll + 0x1000; // start from first section
	DWORD64 dwModuleSize = (DWORD64)moduleInfo.SizeOfImage - 0x1000; // scan size - 0x1000, due to the above

	uint8_t* pMatch = 0;
	int matchCount = 0;

	for ( DWORD64 i = 0; i < dwModuleSize; i++ )
	{
		if ( bDataCompare( (BYTE*)( dwBaseAddress + i ), bMask, szMask ) )
		{
			matchCount++;
			if ( matchCount > 1 )
			{
				// More than one match found, return INVALID_POINTER
				return 0;
			}
			pMatch = (uint8_t*)( dwBaseAddress + i );
		}
	}
	return pMatch;
}

static uint8_t PersuadePros()
{
	uint8_t *pFound = NULL;
	DWORD lpflOldProtect;

	// 48????080FB64304 | +0x4
	// x ? ? x x x x x
	pFound = FindPattern( (PBYTE)"\x48\x00\x00\x08\x0F\xB6\x43\x04", "x??xxxxx" );
	if( IsBadCodePtr( (FARPROC)pFound ) ) return 0;
	// Adjust the pointer to the desired offset
	uint8_t* pOffset = pFound + 0x4;
	VirtualProtect( (LPVOID)pOffset, 0x4, PAGE_EXECUTE_READWRITE, &lpflOldProtect );
	*(BYTE*)( pOffset + 0x2 ) = 0x03;
	*(BYTE*)( pOffset + 0x3 ) = 0x90;
	VirtualProtect( (LPVOID)pOffset, 0x4, lpflOldProtect, &lpflOldProtect );
	return 1;
}

static void LoadOriginalD3D9()
{
    char libpath[MAX_PATH];
    GetSystemDirectory( libpath, MAX_PATH );
    strcat( libpath, "\\d3d9.dll" );
    D3D9_o = LoadLibrary( libpath );
    if( D3D9_o ) imp_Direct3DCreate9 = (LPBYTE)GetProcAddress( D3D9_o, "Direct3DCreate9" );
}

static uint8_t WINAPI DelayThread(LPVOID lpParam)
{
	uint8_t status = 0;
	for (DWORD64 i = 0; i < 20; i++)
	{
		// Wait for 1 second (1,000 milliseconds)
		Sleep(1000);
		status = PersuadePros();
		if ( status > 0 ) return 1;
	}
	MessageBox( 0, "Signature not found; nothing patched.\r\nGame will continue to load.", "<meep, meep!>", MB_ICONERROR );
	return 0;
}

static int __stdcall DllMain( HMODULE hModule, DWORD dwReason, LPVOID lpReserved )
{
	switch ( dwReason )
	{
	case DLL_PROCESS_ATTACH:
		CreateThread( 0, 0, (LPTHREAD_START_ROUTINE)LoadOriginalD3D9, 0, 0, 0 );
		CreateThread( 0, 0, (LPTHREAD_START_ROUTINE)DelayThread, 0, 0, 0 );
		break;

	case DLL_PROCESS_DETACH:
		if( D3D9_o )
		{
			FreeLibrary( D3D9_o );
		}
		break;
	}
	return TRUE;
}